Index: drivers/filesystems/btrfs/btrfs.c
===================================================================
--- drivers/filesystems/btrfs/btrfs.c	(révision 74430)
+++ drivers/filesystems/btrfs/btrfs.c	(copie de travail)
@@ -1,4 +1,4 @@
-/* Copyright (c) Mark Harmstone 2016
+/* Copyright (c) Mark Harmstone 2016-17
  * 
  * This file is part of WinBtrfs.
  * 
@@ -29,13 +29,23 @@
 #endif
 #include <ntddscsi.h>
 #include "btrfs.h"
-#ifndef __REACTOS__
-#include <winioctl.h>
-#else
-#include <rtlfuncs.h>
-#endif
 #include <ata.h>
 
+#ifndef _MSC_VER
+#include <initguid.h>
+#include <ntddstor.h>
+#undef INITGUID
+#endif
+
+#include <ntdddisk.h>
+#include <ntddvol.h>
+
+#ifdef _MSC_VER
+#include <initguid.h>
+#include <ntddstor.h>
+#undef INITGUID
+#endif
+
 #define INCOMPAT_SUPPORTED (BTRFS_INCOMPAT_FLAGS_MIXED_BACKREF | BTRFS_INCOMPAT_FLAGS_DEFAULT_SUBVOL | BTRFS_INCOMPAT_FLAGS_MIXED_GROUPS | \
                             BTRFS_INCOMPAT_FLAGS_COMPRESS_LZO | BTRFS_INCOMPAT_FLAGS_BIG_METADATA | BTRFS_INCOMPAT_FLAGS_RAID56 | \
                             BTRFS_INCOMPAT_FLAGS_EXTENDED_IREF | BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA | BTRFS_INCOMPAT_FLAGS_NO_HOLES)
@@ -51,9 +61,6 @@
 #endif
 UINT64 num_reads = 0;
 LIST_ENTRY uid_map_list;
-LIST_ENTRY volumes;
-ERESOURCE volumes_lock;
-LIST_ENTRY pnp_disks;
 LIST_ENTRY VcbList;
 ERESOURCE global_loading_lock;
 UINT32 debug_log_level = 0;
@@ -63,9 +70,10 @@
 UINT32 mount_zlib_level = 3;
 UINT32 mount_flush_interval = 30;
 UINT32 mount_max_inline = 2048;
-UINT32 mount_raid5_recalculation = 1;
-UINT32 mount_raid6_recalculation = 1;
 UINT32 mount_skip_balance = 0;
+UINT32 mount_no_barrier = 0;
+UINT32 mount_no_trim = 0;
+UINT32 mount_clear_cache = 0;
 BOOL log_started = FALSE;
 UNICODE_STRING log_device, log_file, registry_path;
 tPsUpdateDiskCounters PsUpdateDiskCounters;
@@ -72,8 +80,11 @@
 tCcCopyReadEx CcCopyReadEx;
 tCcCopyWriteEx CcCopyWriteEx;
 tCcSetAdditionalCacheAttributesEx CcSetAdditionalCacheAttributesEx;
+tFsRtlUpdateDiskCounters FsRtlUpdateDiskCounters;
 BOOL diskacc = FALSE;
-void* notification_entry = NULL;
+void *notification_entry = NULL, *notification_entry2 = NULL, *notification_entry3 = NULL;
+ERESOURCE volume_list_lock;
+LIST_ENTRY volume_list;
 
 #ifdef _DEBUG
 PFILE_OBJECT comfo = NULL;
@@ -92,6 +103,8 @@
 static NTSTATUS STDCALL dbg_completion(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID conptr) {
     read_context* context = conptr;
     
+    UNUSED(DeviceObject);
+    
 //     DbgPrint("dbg_completion\n");
     
     context->iosb = Irp->IoStatus;
@@ -112,7 +125,7 @@
     PIRP Irp;
     va_list ap;
     char *buf2 = NULL, *buf;
-    read_context* context = NULL;
+    read_context context;
     UINT32 length;
     
     buf2 = ExAllocatePoolWithTag(NonPagedPool, 1024, ALLOC_TAG);
@@ -146,15 +159,9 @@
         offset.u.LowPart = 0;
         offset.u.HighPart = 0;
         
-        context = ExAllocatePoolWithTag(NonPagedPool, sizeof(read_context), ALLOC_TAG);
-        if (!context) {
-            DbgPrint("Couldn't allocate context in debug_message\n");
-            return;
-        }
+        RtlZeroMemory(&context, sizeof(read_context));
         
-        RtlZeroMemory(context, sizeof(read_context));
-        
-        KeInitializeEvent(&context->Event, NotificationEvent, FALSE);
+        KeInitializeEvent(&context.Event, NotificationEvent, FALSE);
 
     //     status = ZwWriteFile(comh, NULL, NULL, NULL, &io, buf2, strlen(buf2), &offset, NULL);
         
@@ -178,8 +185,8 @@
                 DbgPrint("IoAllocateMdl failed\n");
                 goto exit;
             }
-            
-            MmProbeAndLockPages(Irp->MdlAddress, KernelMode, IoWriteAccess);
+
+            MmBuildMdlForNonPagedPool(Irp->MdlAddress);
         } else {
             Irp->UserBuffer = buf2;
         }
@@ -187,23 +194,21 @@
         IrpSp->Parameters.Write.Length = length;
         IrpSp->Parameters.Write.ByteOffset = offset;
         
-        Irp->UserIosb = &context->iosb;
+        Irp->UserIosb = &context.iosb;
 
-        Irp->UserEvent = &context->Event;
+        Irp->UserEvent = &context.Event;
 
-        IoSetCompletionRoutine(Irp, dbg_completion, context, TRUE, TRUE, TRUE);
+        IoSetCompletionRoutine(Irp, dbg_completion, &context, TRUE, TRUE, TRUE);
 
         Status = IoCallDriver(comdo, Irp);
 
         if (Status == STATUS_PENDING) {
-            KeWaitForSingleObject(&context->Event, Executive, KernelMode, FALSE, NULL);
-            Status = context->iosb.Status;
+            KeWaitForSingleObject(&context.Event, Executive, KernelMode, FALSE, NULL);
+            Status = context.iosb.Status;
         }
         
-        if (comdo->Flags & DO_DIRECT_IO) {
-            MmUnlockPages(Irp->MdlAddress);
+        if (comdo->Flags & DO_DIRECT_IO)
             IoFreeMdl(Irp->MdlAddress);
-        }
         
         if (!NT_SUCCESS(Status)) {
             DbgPrint("failed to write to COM1 - error %08x\n", Status);
@@ -227,9 +232,6 @@
 exit2:
     va_end(ap);
     
-    if (context)
-        ExFreePool(context);
-    
     if (buf2)
         ExFreePool(buf2);
 }
@@ -271,6 +273,20 @@
     
     IoUnregisterFileSystem(DriverObject->DeviceObject);
     
+    if (notification_entry2)
+#ifdef __REACTOS__
+        IoUnregisterPlugPlayNotification(notification_entry2);
+#else
+        IoUnregisterPlugPlayNotificationEx(notification_entry2);
+#endif
+    
+    if (notification_entry3)
+#ifdef __REACTOS__
+        IoUnregisterPlugPlayNotification(notification_entry3);
+#else
+        IoUnregisterPlugPlayNotificationEx(notification_entry3);
+#endif
+    
     if (notification_entry)
 #ifdef __REACTOS__
         IoUnregisterPlugPlayNotification(notification_entry);
@@ -294,7 +310,6 @@
     }
     
     // FIXME - free volumes and their devpaths
-    // FIXME - free pnp_disks and their devpaths
     
 #ifdef _DEBUG
     if (comfo)
@@ -305,9 +320,8 @@
 #endif
     
     ExDeleteResourceLite(&global_loading_lock);
+    ExDeleteResourceLite(&volume_list_lock);
     
-    ExDeleteResourceLite(&volumes_lock);
-    
     if (log_device.Buffer)
         ExFreePool(log_device.Buffer);
     
@@ -340,7 +354,7 @@
         return TRUE;
     }
     
-    while (find_prev_item(Vcb, &tp, &prev_tp, FALSE, Irp)) {
+    while (find_prev_item(Vcb, &tp, &prev_tp, Irp)) {
         tp = prev_tp;
         
         TRACE("moving on to %llx,%x,%llx\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset);
@@ -359,7 +373,7 @@
     return TRUE;
 }
 
-BOOL extract_xattr(void* item, USHORT size, char* name, UINT8** data, UINT16* datalen) {
+static BOOL extract_xattr(void* item, USHORT size, char* name, UINT8** data, UINT16* datalen) {
     DIR_ITEM* xa = (DIR_ITEM*)item;
     USHORT xasize;
     
@@ -444,10 +458,16 @@
 
     top_level = is_top_level(Irp);
     
-    if (DeviceObject == devobj || (Vcb && Vcb->type == VCB_TYPE_PARTITION0)) {
+    if (DeviceObject == devobj) {
         TRACE("Closing file system\n");
         Status = STATUS_SUCCESS;
-        goto exit;
+        goto end;
+    } else if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_close(DeviceObject, Irp);
+        goto end;
+    } else if (!Vcb || Vcb->type != VCB_TYPE_FS) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
     }
     
     IrpSp = IoGetCurrentIrpStackLocation(Irp);
@@ -457,7 +477,7 @@
     
     Status = close_file(DeviceObject->DeviceExtension, IrpSp->FileObject);
 
-exit:
+end:
     Irp->IoStatus.Status = Status;
     Irp->IoStatus.Information = 0;
     
@@ -487,9 +507,12 @@
 
     top_level = is_top_level(Irp);
     
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
-        goto exit;
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_flush_buffers(DeviceObject, Irp);
+        goto end;
+    } else if (!Vcb || Vcb->type != VCB_TYPE_FS) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
     }
     
     Status = STATUS_SUCCESS;
@@ -507,9 +530,9 @@
         Status = Irp->IoStatus.Status;
     }
     
+end:
     IoCompleteRequest(Irp, IO_NO_INCREMENT);
     
-exit:
     if (top_level) 
         IoSetTopLevelIrp(NULL);
     
@@ -542,6 +565,96 @@
     *freespace = sectors_used > *totalsize ? 0 : (*totalsize - sectors_used);
 }
 
+#ifndef __REACTOS__
+// This function exists because we have to lie about our FS type in certain situations. 
+// MPR!MprGetConnection queries the FS type, and compares it to a whitelist. If it doesn't match,
+// it will return ERROR_NO_NET_OR_BAD_PATH, which prevents UAC from working.
+// The command mklink refuses to create hard links on anything other than NTFS, so we have to
+// blacklist cmd.exe too.
+
+static BOOL lie_about_fs_type() {
+    NTSTATUS Status;
+    PROCESS_BASIC_INFORMATION pbi;
+    PPEB peb;
+    LIST_ENTRY* le;
+    ULONG retlen;
+    
+    static WCHAR mpr[] = L"MPR.DLL";
+    static WCHAR cmd[] = L"CMD.EXE";
+    UNICODE_STRING mprus, cmdus;
+    
+    mprus.Buffer = mpr;
+    mprus.Length = mprus.MaximumLength = wcslen(mpr) * sizeof(WCHAR);
+    cmdus.Buffer = cmd;
+    cmdus.Length = cmdus.MaximumLength = wcslen(cmd) * sizeof(WCHAR);
+    
+    if (!PsGetCurrentProcess())
+        return FALSE;
+    
+    Status = ZwQueryInformationProcess(NtCurrentProcess(), ProcessBasicInformation, &pbi, sizeof(pbi), &retlen);
+    
+    if (!NT_SUCCESS(Status)) {
+        ERR("ZwQueryInformationProcess returned %08x\n", Status);
+        return FALSE;
+    }
+
+    if (!pbi.PebBaseAddress)
+        return FALSE;
+    
+    peb = pbi.PebBaseAddress;
+    
+    if (!peb->Ldr)
+        return FALSE;
+    
+    le = peb->Ldr->InMemoryOrderModuleList.Flink;
+    while (le != &peb->Ldr->InMemoryOrderModuleList) {
+        LDR_DATA_TABLE_ENTRY* entry = CONTAINING_RECORD(le, LDR_DATA_TABLE_ENTRY, InMemoryOrderLinks);
+        BOOL blacklist = FALSE;
+        
+        if (entry->FullDllName.Length >= mprus.Length) {
+            UNICODE_STRING name;
+            
+            name.Buffer = &entry->FullDllName.Buffer[(entry->FullDllName.Length - mprus.Length) / sizeof(WCHAR)];
+            name.Length = name.MaximumLength = mprus.Length;
+            
+            blacklist = FsRtlAreNamesEqual(&name, &mprus, TRUE, NULL);
+        }
+        
+        if (!blacklist && entry->FullDllName.Length >= cmdus.Length) {
+            UNICODE_STRING name;
+            
+            name.Buffer = &entry->FullDllName.Buffer[(entry->FullDllName.Length - cmdus.Length) / sizeof(WCHAR)];
+            name.Length = name.MaximumLength = cmdus.Length;
+            
+            blacklist = FsRtlAreNamesEqual(&name, &cmdus, TRUE, NULL);
+        }
+        
+        if (blacklist) {
+            void** frames;
+            USHORT i, num_frames;
+            
+            frames = ExAllocatePoolWithTag(PagedPool, 256 * sizeof(void*), ALLOC_TAG);
+
+            num_frames = RtlWalkFrameChain(frames, 256, 1);
+            
+            for (i = 0; i < num_frames; i++) {
+                // entry->Reserved3[1] appears to be the image size
+                if (frames[i] >= entry->DllBase && (ULONG_PTR)frames[i] <= (ULONG_PTR)entry->DllBase + (ULONG_PTR)entry->Reserved3[1]) {
+                    ExFreePool(frames);
+                    return TRUE;
+                }
+            }
+            
+            ExFreePool(frames);
+        }
+        
+        le = le->Flink;
+    }
+
+    return FALSE;
+}
+#endif
+
 static NTSTATUS STDCALL drv_query_volume_information(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
     PIO_STACK_LOCATION IrpSp;
     NTSTATUS Status;
@@ -549,28 +662,18 @@
     device_extension* Vcb = DeviceObject->DeviceExtension;
     BOOL top_level;
     
-#ifndef __REACTOS__
-    // An unfortunate necessity - we have to lie about our FS type. MPR!MprGetConnection polls for this,
-    // and compares it to a whitelist. If it doesn't match, it will return ERROR_NO_NET_OR_BAD_PATH,
-    // which prevents UAC from working.
-    // FIXME - only lie if we detect that we're being called by mpr.dll
-    
-    WCHAR* fs_name = L"NTFS";
-    ULONG fs_name_len = 4 * sizeof(WCHAR);
-#else
-    WCHAR* fs_name = L"Btrfs";
-    ULONG fs_name_len = 5 * sizeof(WCHAR);
-#endif
-
     TRACE("query volume information\n");
     
     FsRtlEnterFileSystem();
     top_level = is_top_level(Irp);
     
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
-        goto exit;
-    }    
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_query_volume_information(DeviceObject, Irp);
+        goto end;
+    } else if (!Vcb || Vcb->type != VCB_TYPE_FS) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
+    }
     
     IrpSp = IoGetCurrentIrpStackLocation(Irp);
     
@@ -581,6 +684,12 @@
         {
             FILE_FS_ATTRIBUTE_INFORMATION* data = Irp->AssociatedIrp.SystemBuffer;
             BOOL overflow = FALSE;
+#ifndef __REACTOS__
+            WCHAR* fs_name = (Irp->RequestorMode == UserMode && lie_about_fs_type()) ? L"NTFS" : L"Btrfs";
+#else
+            WCHAR* fs_name = L"Btrfs";
+#endif
+            ULONG fs_name_len = wcslen(fs_name) * sizeof(WCHAR);
             ULONG orig_fs_name_len = fs_name_len;
             
             TRACE("FileFsAttributeInformation\n");
@@ -611,10 +720,6 @@
             break;
         }
 
-        case FileFsControlInformation:
-            FIXME("STUB: FileFsControlInformation\n");
-            break;
-
         case FileFsDeviceInformation:
         {
             FILE_FS_DEVICE_INFORMATION* ffdi = Irp->AssociatedIrp.SystemBuffer;
@@ -624,7 +729,7 @@
             ffdi->DeviceType = FILE_DEVICE_DISK;
             
             ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
-            ffdi->Characteristics = first_device(Vcb)->devobj->Characteristics;
+            ffdi->Characteristics = Vcb->Vpb->RealDevice->Characteristics;
             ExReleaseResourceLite(&Vcb->tree_lock);
             
             if (Vcb->readonly)
@@ -638,10 +743,6 @@
             break;
         }
 
-        case FileFsDriverPathInformation:
-            FIXME("STUB: FileFsDriverPathInformation\n");
-            break;
-
         case FileFsFullSizeInformation:
         {
             FILE_FS_FULL_SIZE_INFORMATION* ffsi = Irp->AssociatedIrp.SystemBuffer;
@@ -754,7 +855,7 @@
             
             data->Flags = SSINFO_FLAGS_ALIGNED_DEVICE | SSINFO_FLAGS_PARTITION_ALIGNED_ON_DEVICE;
             
-            if (Vcb->trim)
+            if (Vcb->trim && !Vcb->options.no_trim)
                 data->Flags |= SSINFO_FLAGS_TRIM_ENABLED;
             
             BytesCopied = sizeof(FILE_FS_SECTOR_SIZE_INFORMATION);
@@ -776,16 +877,16 @@
 //         Status = STATUS_BUFFER_OVERFLOW;
 //     }
 
-    Irp->IoStatus.Status = Status;
-    
     if (!NT_SUCCESS(Status) && Status != STATUS_BUFFER_OVERFLOW)
         Irp->IoStatus.Information = 0;
     else
         Irp->IoStatus.Information = BytesCopied;
     
+end:
+    Irp->IoStatus.Status = Status;
+    
     IoCompleteRequest( Irp, IO_DISK_INCREMENT );
     
-exit:
     if (top_level) 
         IoSetTopLevelIrp(NULL);
     
@@ -799,6 +900,8 @@
 static NTSTATUS STDCALL read_completion(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID conptr) {
     read_context* context = conptr;
     
+    UNUSED(DeviceObject);
+    
 //     DbgPrint("read_completion\n");
     
     context->iosb = Irp->IoStatus;
@@ -808,74 +911,8 @@
     return STATUS_MORE_PROCESSING_REQUIRED;
 }
 
-// static void test_tree_deletion(device_extension* Vcb) {
-//     KEY searchkey/*, endkey*/;
-//     traverse_ptr tp, next_tp;
-//     root* r;
-//     
-//     searchkey.obj_id = 0x100;
-//     searchkey.obj_type = 0x54;
-//     searchkey.offset = 0xca4ab2f5;
-//     
-// //     endkey.obj_id = 0x100;
-// //     endkey.obj_type = 0x60;
-// //     endkey.offset = 0x15a;
-//     
-//     r = Vcb->roots;
-//     while (r && r->id != 0x102)
-//         r = r->next;
-//     
-//     if (!r) {
-//         ERR("error - could not find root\n");
-//         return;
-//     }
-//     
-//     if (!find_item(Vcb, r, &tp, &searchkey, NULL, FALSE)) {
-//         ERR("error - could not find key\n");
-//         return;
-//     }
-//     
-//     while (TRUE/*keycmp(tp.item->key, endkey) < 1*/) {
-//         tp.item->ignore = TRUE;
-//         add_to_tree_cache(tc, tp.tree);
-//         
-//         if (find_next_item(Vcb, &tp, &next_tp, NULL, FALSE)) {
-//             free_traverse_ptr(&tp);
-//             tp = next_tp;
-//         } else
-//             break;
-//     }
-//     
-//     free_traverse_ptr(&tp);
-// }
-
-// static void test_tree_splitting(device_extension* Vcb) {
-//     int i;
-//     
-//     for (i = 0; i < 1000; i++) {
-//         char* data = ExAllocatePoolWithTag(PagedPool, 4, ALLOC_TAG);
-//         
-//         insert_tree_item(Vcb, Vcb->extent_root, 0, 0xfd, i, data, 4, NULL);
-//     }
-// }
-
-// static void test_dropping_tree(device_extension* Vcb) {
-//     LIST_ENTRY* le = Vcb->roots.Flink;
-//     
-//     while (le != &Vcb->roots) {
-//         root* r = CONTAINING_RECORD(le, root, list_entry);
-//         
-//         if (r->id == 0x101) {
-//             RemoveEntryList(&r->list_entry);
-//             InsertTailList(&Vcb->drop_roots, &r->list_entry);
-//             return;
-//         }
-//         
-//         le = le->Flink;
-//     }
-// }
-
-NTSTATUS create_root(device_extension* Vcb, UINT64 id, root** rootptr, BOOL no_tree, UINT64 offset, PIRP Irp, LIST_ENTRY* rollback) {
+NTSTATUS create_root(device_extension* Vcb, UINT64 id, root** rootptr, BOOL no_tree, UINT64 offset, PIRP Irp) {
+    NTSTATUS Status;
     root* r;
     tree* t;
     ROOT_ITEM* ri;
@@ -902,6 +939,10 @@
             ExFreePool(r);
             return STATUS_INSUFFICIENT_RESOURCES;
         }
+        
+        t->is_unique = TRUE;
+        t->uniqueness_determined = TRUE;
+        t->buf = NULL;
     }
     
     ri = ExAllocatePoolWithTag(PagedPool, sizeof(ROOT_ITEM), ALLOC_TAG);
@@ -931,8 +972,9 @@
     // We ask here for a traverse_ptr to the item we're inserting, so we can
     // copy some of the tree's variables
     
-    if (!insert_tree_item(Vcb, Vcb->root_root, id, TYPE_ROOT_ITEM, offset, ri, sizeof(ROOT_ITEM), &tp, Irp, rollback)) {
-        ERR("insert_tree_item failed\n");
+    Status = insert_tree_item(Vcb, Vcb->root_root, id, TYPE_ROOT_ITEM, offset, ri, sizeof(ROOT_ITEM), &tp, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
         ExFreePool(ri);
         
         if (!no_tree)
@@ -940,7 +982,7 @@
         
         ExFreePool(r->nonpaged);
         ExFreePool(r);
-        return STATUS_INTERNAL_ERROR;
+        return Status;
     }
         
     ExInitializeResourceLite(&r->nonpaged->load_tree_lock);
@@ -982,284 +1024,6 @@
     return STATUS_SUCCESS;
 }
 
-// static void test_creating_root(device_extension* Vcb) {
-//     NTSTATUS Status;
-//     LIST_ENTRY rollback;
-//     UINT64 id;
-//     root* r;
-//     
-//     InitializeListHead(&rollback);
-//     
-//     if (Vcb->root_root->lastinode == 0)
-//         get_last_inode(Vcb, Vcb->root_root);
-//     
-//     id = Vcb->root_root->lastinode > 0x100 ? (Vcb->root_root->lastinode + 1) : 0x101;
-//     Status = create_root(Vcb, id, &r, &rollback);
-//     
-//     if (!NT_SUCCESS(Status)) {
-//         ERR("create_root returned %08x\n", Status);
-//         do_rollback(Vcb, &rollback);
-//     } else {
-//         Vcb->root_root->lastinode = id;
-//         clear_rollback(&rollback);
-//     }
-// }
-
-// static void test_alloc_chunk(device_extension* Vcb) {
-//     LIST_ENTRY rollback;
-//     chunk* c;
-//     
-//     InitializeListHead(&rollback);
-//     
-//     c = alloc_chunk(Vcb, BLOCK_FLAG_DATA | BLOCK_FLAG_RAID10, &rollback);
-//     if (!c) {
-//         ERR("alloc_chunk failed\n");
-//         do_rollback(Vcb, &rollback);
-//     } else {
-//         clear_rollback(&rollback);
-//     }
-// }
-
-// static void test_space_list(device_extension* Vcb) {
-//     chunk* c;
-//     int i, j;
-//     LIST_ENTRY* le;
-//     
-//     typedef struct {
-//         UINT64 address;
-//         UINT64 length;
-//         BOOL add;
-//     } space_test;
-//     
-//     static const space_test entries[] = {
-//         { 0x1000, 0x1000 },
-//         { 0x3000, 0x2000 },
-//         { 0x6000, 0x1000 },
-//         { 0, 0 }
-//     };
-//     
-//     static const space_test tests[] = {
-//         { 0x0, 0x800, TRUE }, 
-//         { 0x1800, 0x400, TRUE }, 
-//         { 0x800, 0x2000, TRUE }, 
-//         { 0x1000, 0x2000, TRUE }, 
-//         { 0x2000, 0x3800, TRUE }, 
-//         { 0x800, 0x1000, TRUE }, 
-//         { 0x1800, 0x1000, TRUE }, 
-//         { 0x5000, 0x800, TRUE }, 
-//         { 0x5000, 0x1000, TRUE }, 
-//         { 0x7000, 0x1000, TRUE }, 
-//         { 0x8000, 0x1000, TRUE },
-//         { 0x800, 0x800, TRUE }, 
-//         { 0x0, 0x3800, TRUE }, 
-//         { 0x1000, 0x2800, TRUE },
-//         { 0x1000, 0x1000, FALSE },
-//         { 0x800, 0x2000, FALSE },
-//         { 0x0, 0x3800, FALSE },
-//         { 0x2800, 0x1000, FALSE },
-//         { 0x1800, 0x2000, FALSE },
-//         { 0x3800, 0x1000, FALSE },
-//         { 0, 0, FALSE }
-//     };
-//     
-//     c = CONTAINING_RECORD(Vcb->chunks.Flink, chunk, list_entry);
-//     
-//     i = 0;
-//     while (tests[i].length > 0) {
-//         InitializeListHead(&c->space);
-//         InitializeListHead(&c->space_size);
-//         ERR("test %u\n", i);
-//         
-//         j = 0;
-//         while (entries[j].length > 0) {
-//             space* s = ExAllocatePoolWithTag(PagedPool, sizeof(space), ALLOC_TAG);
-//             s->address = entries[j].address;
-//             s->size = entries[j].length;
-//             InsertTailList(&c->space, &s->list_entry);
-//             
-//             order_space_entry(s, &c->space_size);
-//             
-//             j++;
-//         }
-//         
-//         if (tests[i].add)
-//             space_list_add(Vcb, c, FALSE, tests[i].address, tests[i].length, NULL);
-//         else
-//             space_list_subtract(Vcb, c, FALSE, tests[i].address, tests[i].length, NULL);
-//         
-//         le = c->space.Flink;
-//         while (le != &c->space) {
-//             space* s = CONTAINING_RECORD(le, space, list_entry);
-//             
-//             ERR("(%llx,%llx)\n", s->address, s->size);
-//             
-//             le = le->Flink;
-//         }
-//         
-//         ERR("--\n");
-//         
-//         le = c->space_size.Flink;
-//         while (le != &c->space_size) {
-//             space* s = CONTAINING_RECORD(le, space, list_entry_size);
-//             
-//             ERR("(%llx,%llx)\n", s->address, s->size);
-//             
-//             le = le->Flink;
-//         }
-//         
-//         i++;
-//     }
-//     
-//     int3;
-// }
-
-#if 0
-void STDCALL tree_test(void* context) {
-    device_extension* Vcb = context;
-    NTSTATUS Status;
-    UINT64 id;
-    LARGE_INTEGER due_time, time;
-    KTIMER timer;
-    root* r;
-    LIST_ENTRY rollback;
-    ULONG seed;
-    
-    InitializeListHead(&rollback);
-    
-    KeInitializeTimer(&timer);
-    
-    id = InterlockedIncrement64(&Vcb->root_root->lastinode);
-    Status = create_root(Vcb, id, &r, FALSE, 0, NULL, &rollback);
-    if (!NT_SUCCESS(Status)) {
-        ERR("create_root returned %08x\n");
-        return;
-    }
-    
-    clear_rollback(Vcb, &rollback);
-    
-    due_time.QuadPart = (UINT64)1 * -10000000;
-    
-    KeQueryPerformanceCounter(&time);
-    seed = time.LowPart;
-    
-    while (TRUE) {
-        UINT32 i;
-        
-        FsRtlEnterFileSystem();
-        
-        ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
-        
-        for (i = 0; i < 100; i++) {
-            void* data;
-            ULONG datalen;
-            UINT64 objid, offset;
-            
-            objid = RtlRandomEx(&seed);
-            objid <<= 32;
-            objid |= RtlRandomEx(&seed);
-            
-            offset = RtlRandomEx(&seed);
-            offset <<= 32;
-            offset |= RtlRandomEx(&seed);
-            
-            datalen = 30;
-            data = ExAllocatePoolWithTag(PagedPool, datalen, ALLOC_TAG);
-            
-            if (!insert_tree_item(Vcb, r, objid, 0xfd, offset, data, datalen, NULL, NULL, &rollback)) {
-                ERR("insert_tree_item failed\n");
-            }
-        }
-        
-        for (i = 0; i < 25; i++) {
-            KEY searchkey;
-            traverse_ptr tp;
-            
-            searchkey.obj_id = RtlRandomEx(&seed);
-            searchkey.obj_id <<= 32;
-            searchkey.obj_id |= RtlRandomEx(&seed);
-            
-            searchkey.obj_type = 0xfd;
-            
-            searchkey.offset = RtlRandomEx(&seed);
-            searchkey.offset <<= 32;
-            searchkey.offset |= RtlRandomEx(&seed);
-            
-            Status = find_item(Vcb, r, &tp, &searchkey, FALSE, NULL);
-            if (!NT_SUCCESS(Status)) {
-                ERR("error - find_item returned %08x\n", Status);
-            } else {
-                delete_tree_item(Vcb, &tp, &rollback);
-            }
-        }
-        
-        clear_rollback(Vcb, &rollback);
-        
-        ExReleaseResourceLite(&Vcb->tree_lock);
-        
-        FsRtlExitFileSystem();
-        
-        KeSetTimer(&timer, due_time, NULL);
-        
-        KeWaitForSingleObject(&timer, Executive, KernelMode, FALSE, NULL);
-    }
-}
-#endif
-
-// static void test_calc_thread(device_extension* Vcb) {
-//     UINT8* data;
-//     ULONG sectors, max_sectors, i, j;
-//     calc_job* cj;
-//     LARGE_INTEGER* sertimes;
-//     LARGE_INTEGER* partimes;
-//     LARGE_INTEGER time1, time2;
-//     
-//     max_sectors = 256;
-//     
-//     sertimes = ExAllocatePoolWithTag(PagedPool, sizeof(LARGE_INTEGER) * max_sectors, ALLOC_TAG);
-//     partimes = ExAllocatePoolWithTag(PagedPool, sizeof(LARGE_INTEGER) * max_sectors, ALLOC_TAG);
-//     RtlZeroMemory(sertimes, sizeof(LARGE_INTEGER) * max_sectors);
-//     RtlZeroMemory(partimes, sizeof(LARGE_INTEGER) * max_sectors);
-//     
-//     for (sectors = 1; sectors <= max_sectors; sectors++) {
-//         data = ExAllocatePoolWithTag(PagedPool, sectors * Vcb->superblock.sector_size, ALLOC_TAG);
-//         RtlZeroMemory(data, sectors * Vcb->superblock.sector_size);
-//         
-//         for (j = 0; j < 100; j++) {
-//             time1 = KeQueryPerformanceCounter(NULL);
-//             
-//             for (i = 0; i < sectors; i++) {
-//                 UINT32 tmp;
-//                 
-//                 tmp = ~calc_crc32c(0xffffffff, data + (i * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
-//             }
-//             
-//             time2 = KeQueryPerformanceCounter(NULL);
-//             
-//             sertimes[sectors - 1].QuadPart += time2.QuadPart - time1.QuadPart;
-//             
-//             time1 = KeQueryPerformanceCounter(NULL);
-//             
-//             add_calc_job(Vcb, data, sectors, &cj);
-//             KeWaitForSingleObject(&cj->event, Executive, KernelMode, FALSE, NULL);
-//             
-//             time2 = KeQueryPerformanceCounter(NULL);
-//             
-//             partimes[sectors - 1].QuadPart += time2.QuadPart - time1.QuadPart;
-//             
-//             free_calc_job(cj);
-//         }
-//         
-//         ExFreePool(data);
-//     }
-//     
-//     for (sectors = 1; sectors <= max_sectors; sectors++) {
-//         ERR("%u sectors: serial %llu, parallel %llu\n", sectors, sertimes[sectors - 1].QuadPart, partimes[sectors - 1].QuadPart);
-//     }
-//     
-//     ExFreePool(partimes);
-//     ExFreePool(sertimes);
-// }
-
 static NTSTATUS STDCALL set_label(device_extension* Vcb, FILE_FS_LABEL_INFORMATION* ffli) {
     ULONG utf8len;
     NTSTATUS Status;
@@ -1338,9 +1102,12 @@
 
     top_level = is_top_level(Irp);
     
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
-        goto exit;
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_set_volume_information(DeviceObject, Irp);
+        goto end;
+    } else if (!Vcb || Vcb->type != VCB_TYPE_FS) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
     }
     
     Status = STATUS_NOT_IMPLEMENTED;
@@ -1381,7 +1148,6 @@
 
     IoCompleteRequest( Irp, IO_NO_INCREMENT );
     
-exit:
     if (top_level) 
         IoSetTopLevelIrp(NULL);
     
@@ -1428,26 +1194,33 @@
 WCHAR* file_desc_fileref(file_ref* fileref) {
     NTSTATUS Status;
     UNICODE_STRING fn;
+    ULONG reqlen;
     
     if (fileref->debug_desc)
         return fileref->debug_desc;
     
-    Status = fileref_get_filename(fileref, &fn, NULL);
-    if (!NT_SUCCESS(Status)) {
+    fn.Length = fn.MaximumLength = 0;
+    Status = fileref_get_filename(fileref, &fn, NULL, &reqlen);
+    if (Status != STATUS_BUFFER_OVERFLOW)
         return L"ERROR";
-    }
     
-    fileref->debug_desc = ExAllocatePoolWithTag(PagedPool, fn.Length + sizeof(WCHAR), ALLOC_TAG);
-    if (!fileref->debug_desc) {
-        ExFreePool(fn.Buffer);
+    fileref->debug_desc = ExAllocatePoolWithTag(PagedPool, reqlen + sizeof(WCHAR), ALLOC_TAG);
+    if (!fileref->debug_desc)
         return L"(memory error)";
+    
+    fn.Buffer = fileref->debug_desc;
+    fn.Length = 0;
+    fn.MaximumLength = reqlen + sizeof(WCHAR);
+    
+    Status = fileref_get_filename(fileref, &fn, NULL, &reqlen);
+    if (!NT_SUCCESS(Status)) {
+        ExFreePool(fileref->debug_desc);
+        fileref->debug_desc = NULL;
+        return L"ERROR";
     }
     
-    RtlCopyMemory(fileref->debug_desc, fn.Buffer, fn.Length);
     fileref->debug_desc[fn.Length / sizeof(WCHAR)] = 0;
-    
-    ExFreePool(fn.Buffer);
-    
+
     return fileref->debug_desc;
 }
 
@@ -1465,12 +1238,30 @@
 void send_notification_fileref(file_ref* fileref, ULONG filter_match, ULONG action) {
     UNICODE_STRING fn;
     NTSTATUS Status;
+    ULONG reqlen;
     USHORT name_offset;
     fcb* fcb = fileref->fcb;
     
-    Status = fileref_get_filename(fileref, &fn, &name_offset);
+    fn.Length = fn.MaximumLength = 0;
+    Status = fileref_get_filename(fileref, &fn, NULL, &reqlen);
+    if (Status != STATUS_BUFFER_OVERFLOW) {
+        ERR("fileref_get_filename returned %08x\n", Status);
+        return;
+    }
+    
+    fn.Buffer = ExAllocatePoolWithTag(PagedPool, reqlen, ALLOC_TAG);
+    if (!fn.Buffer) {
+        ERR("out of memory\n");
+        return;
+    }
+    
+    fn.MaximumLength = reqlen;
+    fn.Length = 0;
+    
+    Status = fileref_get_filename(fileref, &fn, &name_offset, &reqlen);
     if (!NT_SUCCESS(Status)) {
         ERR("fileref_get_filename returned %08x\n", Status);
+        ExFreePool(fn.Buffer);
         return;
     }
     
